--- a/ngx_http_xslt_filter_module.c	2008-08-04 21:48:15.000000000 +0700
+++ b/ngx_http_xslt_filter_module.c	2008-08-05 13:57:16.000000000 +0700
@@ -131,21 +131,21 @@
 static ngx_command_t  ngx_http_xslt_filter_commands[] = {
 
     { ngx_string("xml_entities"),
-      NGX_HTTP_LOC_CONF|NGX_HTTP_LIF_CONF|NGX_CONF_TAKE1,
+      NGX_HTTP_MAIN_CONF|NGX_HTTP_SRV_CONF|NGX_HTTP_LOC_CONF|NGX_CONF_TAKE1,
       ngx_http_xslt_entities,
       NGX_HTTP_LOC_CONF_OFFSET,
       0,
       NULL },
 
     { ngx_string("xslt_stylesheet"),
-      NGX_HTTP_LOC_CONF|NGX_HTTP_LIF_CONF|NGX_CONF_1MORE,
+      NGX_HTTP_MAIN_CONF|NGX_HTTP_SRV_CONF|NGX_HTTP_LOC_CONF|NGX_CONF_1MORE,
       ngx_http_xslt_stylesheet,
       NGX_HTTP_LOC_CONF_OFFSET,
       0,
       NULL },
 
     { ngx_string("xslt_types"),
-      NGX_HTTP_LOC_CONF|NGX_HTTP_LIF_CONF|NGX_CONF_1MORE,
+      NGX_HTTP_MAIN_CONF|NGX_HTTP_SRV_CONF|NGX_HTTP_LOC_CONF|NGX_CONF_1MORE,
       ngx_http_types_slot,
       NGX_HTTP_LOC_CONF_OFFSET,
       offsetof(ngx_http_xslt_filter_conf_t, keys),
@@ -774,6 +774,14 @@
 
         /* reset array elements */
         ctx->params.nelts = 0;
+
+        /* check whether media-type="..." is set in xslt */
+        if (sheet[i].stylesheet->mediaType &&
+            !ngx_strncmp(sheet[i].stylesheet->mediaType, "text/html",
+                         sizeof("text/html") - 1)) {
+
+            doc->type = XML_HTML_DOCUMENT_NODE;
+        }
     }
 
     ngx_log_debug1(NGX_LOG_DEBUG_HTTP, r->connection->log, 0,